part of openrqm.api;

class RQMDocument {
  
  int id = null;
  
  int workspaceId = null;
  
  int internalIdentifier = null;
  
  int externalIdentifier = null;
  
  String name = null;
  
  String shortName = null;
  
  String description = null;
  
  String confidentiality = null;
  
  int authorId = null;
  
  int languageId = null;
  
  int approverId = null;
  
  String reviewerText = null;
  
  int lastModifiedById = null;
  
  DateTime lastModifiedOn = null;
  
  int baselineMajor = null;
  
  int baselineMinor = null;
  
  int baselineReview = null;
  
  int previousBaselineId = null;
  RQMDocument();

  @override
  String toString() {
    return 'RQMDocument[id=$id, workspaceId=$workspaceId, internalIdentifier=$internalIdentifier, externalIdentifier=$externalIdentifier, name=$name, shortName=$shortName, description=$description, confidentiality=$confidentiality, authorId=$authorId, languageId=$languageId, approverId=$approverId, reviewerText=$reviewerText, lastModifiedById=$lastModifiedById, lastModifiedOn=$lastModifiedOn, baselineMajor=$baselineMajor, baselineMinor=$baselineMinor, baselineReview=$baselineReview, previousBaselineId=$previousBaselineId, ]';
  }

  RQMDocument.fromJson(Map<String, dynamic> json) {
    if (json == null) return;
    id = json['id'];
    workspaceId = json['workspace_id'];
    internalIdentifier = json['internal_identifier'];
    externalIdentifier = json['external_identifier'];
    name = json['name'];
    shortName = json['short_name'];
    description = json['description'];
    confidentiality = json['confidentiality'];
    authorId = json['author_id'];
    languageId = json['language_id'];
    approverId = json['approver_id'];
    reviewerText = json['reviewer_text'];
    lastModifiedById = json['last_modified_by_id'];
    lastModifiedOn = (json['last_modified_on'] == null) ?
      null :
      DateTime.parse(json['last_modified_on']);
    baselineMajor = json['baseline_major'];
    baselineMinor = json['baseline_minor'];
    baselineReview = json['baseline_review'];
    previousBaselineId = json['previous_baseline_id'];
  }

  Map<String, dynamic> toJson() {
    Map <String, dynamic> json = {};
    if (id != null)
      json['id'] = id;
    if (workspaceId != null)
      json['workspace_id'] = workspaceId;
    if (internalIdentifier != null)
      json['internal_identifier'] = internalIdentifier;
    if (externalIdentifier != null)
      json['external_identifier'] = externalIdentifier;
    if (name != null)
      json['name'] = name;
    if (shortName != null)
      json['short_name'] = shortName;
    if (description != null)
      json['description'] = description;
    if (confidentiality != null)
      json['confidentiality'] = confidentiality;
    if (authorId != null)
      json['author_id'] = authorId;
    if (languageId != null)
      json['language_id'] = languageId;
    if (approverId != null)
      json['approver_id'] = approverId;
    if (reviewerText != null)
      json['reviewer_text'] = reviewerText;
    if (lastModifiedById != null)
      json['last_modified_by_id'] = lastModifiedById;
    if (lastModifiedOn != null)
      json['last_modified_on'] = lastModifiedOn == null ? null : lastModifiedOn.toUtc().toIso8601String();
    if (baselineMajor != null)
      json['baseline_major'] = baselineMajor;
    if (baselineMinor != null)
      json['baseline_minor'] = baselineMinor;
    if (baselineReview != null)
      json['baseline_review'] = baselineReview;
    if (previousBaselineId != null)
      json['previous_baseline_id'] = previousBaselineId;
    return json;
  }

  static List<RQMDocument> listFromJson(List<dynamic> json) {
    return json == null ? List<RQMDocument>() : json.map((value) => RQMDocument.fromJson(value)).toList();
  }

  static Map<String, RQMDocument> mapFromJson(Map<String, dynamic> json) {
    var map = Map<String, RQMDocument>();
    if (json != null && json.isNotEmpty) {
      json.forEach((String key, dynamic value) => map[key] = RQMDocument.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of RQMDocument-objects as value to a dart map
  static Map<String, List<RQMDocument>> mapListFromJson(Map<String, dynamic> json) {
    var map = Map<String, List<RQMDocument>>();
     if (json != null && json.isNotEmpty) {
       json.forEach((String key, dynamic value) {
         map[key] = RQMDocument.listFromJson(value);
       });
     }
     return map;
  }
}

